/*
 * ModyfikatorRegul.java
 *
 * Created on 25 stycze 2005, 11:18
 */

package jsampa;

import java.awt.Toolkit;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;
import java.util.Vector;
import javax.swing.DefaultListModel;

import javax.swing.JOptionPane;

/**
 *
 * @author  michalus
 */
public class ModyfikatorRegul extends javax.swing.JPanel {
    
    private SampaEngine se;
    private DefaultListModel model;
    
    /** Creates new form ModyfikatorRegul */
    public ModyfikatorRegul(SampaEngine se) {
        
        this.se = se;
        
        odswiezListe();
        
        initComponents();
        
    }
    
    public void odswiezListe() {
        
        if(model == null) 
            model = new DefaultListModel();
        
        if(model.size()>0)
            model.removeAllElements();
        
        ZarzadcaRegul zr = se.getZarzadcaRegul();
        for(int i=0; i<zr.size(); i++) {
            Regula r = (Regula)zr.get(i);
            
            String s = "";
            s += ""+i+": ";
            s += "\""+r.getWzorzec()+"\" ->";
            
            for(int k=0; k<r.getIloscDifonow(); k++) {
                s+= " *"+r.getDifon(k)+"*";
            }
            
            s+= " (pocztek: "+r.getPoczatek()+";";
            s+= " waga: "+r.getWaga()+"; ";
            s+= " przesunicie: "+r.getPrzesuniecie()+")";
            
            model.addElement(s);
        }
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        skrolRegul = new javax.swing.JScrollPane();
        listaRegul = new javax.swing.JList(model);
        toolbar = new javax.swing.JToolBar();
        bDodaj = new javax.swing.JButton();
        jSeparator2 = new javax.swing.JSeparator();
        bUsun = new javax.swing.JButton();
        bModyfikuj = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        bZapisz = new javax.swing.JButton();
        bWgraj = new javax.swing.JButton();
        jSeparator3 = new javax.swing.JSeparator();

        setLayout(new java.awt.BorderLayout());

        skrolRegul.setViewportView(listaRegul);

        add(skrolRegul, java.awt.BorderLayout.CENTER);

        bDodaj.setText("Dodaj now\u0105");
        bDodaj.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bDodajActionPerformed(evt);
            }
        });

        toolbar.add(bDodaj);

        jSeparator2.setOrientation(javax.swing.SwingConstants.VERTICAL);
        toolbar.add(jSeparator2);

        bUsun.setText("Usu\u0144 zaznaczone");
        bUsun.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bUsunActionPerformed(evt);
            }
        });

        toolbar.add(bUsun);

        bModyfikuj.setText("Modyfikuj zaznaczone");
        bModyfikuj.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bModyfikujActionPerformed(evt);
            }
        });

        toolbar.add(bModyfikuj);

        jSeparator1.setOrientation(javax.swing.SwingConstants.VERTICAL);
        toolbar.add(jSeparator1);

        bZapisz.setText("Zapisz");
        bZapisz.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bZapiszActionPerformed(evt);
            }
        });

        toolbar.add(bZapisz);

        bWgraj.setText("Wgraj");
        bWgraj.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bWgrajActionPerformed(evt);
            }
        });

        toolbar.add(bWgraj);

        jSeparator3.setOrientation(javax.swing.SwingConstants.VERTICAL);
        toolbar.add(jSeparator3);

        add(toolbar, java.awt.BorderLayout.NORTH);

    }//GEN-END:initComponents

    private void bWgrajActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bWgrajActionPerformed

        //wgraj
        
        Properties ustawienia = new Properties();
        
        String filename = JOptionPane.showInputDialog(null, "Podaj nazw pliku z reguami", "reguly");
        
        try {
            FileInputStream in = new FileInputStream(filename+".xml");
            ustawienia.loadFromXML(in);
            in.close();
            
            ZarzadcaRegul zr = se.getZarzadcaRegul();
            zr.removeAll();
            
            int iloscRegul = Integer.parseInt(ustawienia.getProperty("ilosc", "-1"));
            
            for(int k=0; k<iloscRegul; k++) {
                                
                String token = "";
                String s = ustawienia.getProperty(""+k, "1;2;3;4;5;6;7;8;");
                Vector sparsowane = new Vector();
                int n = 0;
                
                for(int i=0; i<s.length(); i++) {
                    if(s.charAt(i)==';') {
                        sparsowane.add(new String(token));
                        token = "";
                    } else {
                        token += ""+s.charAt(i);
                    }
                }
                
                int poczatek = Integer.parseInt((String)sparsowane.get(0));
                int waga = Integer.parseInt((String)sparsowane.get(2));
                int przesuniecie = Integer.parseInt((String)sparsowane.get(1)); 
                String wzorzec = (String)sparsowane.get(3);
                int iloscDifonow = Integer.parseInt((String)sparsowane.get(4)); 
                
                String[] difony = new String[iloscDifonow];
                for(int j=0; j<iloscDifonow; j++) {
                    difony[j] = (String)sparsowane.get(j+5);
                }
                
                zr.add(new Regula(poczatek, wzorzec, difony, przesuniecie, waga));                
            }
            
            zr.porzadkuj();
            odswiezListe();
            
        } catch(IOException eio) {
            System.out.println("Ustawienia nie byy wczeniej zapisywane.");
        } catch(NumberFormatException nfo) {
            System.out.println("Bledy w pliku konfiguracyjnym.");
        }
        
    }//GEN-LAST:event_bWgrajActionPerformed
    
    private void bZapiszActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bZapiszActionPerformed
        
        //zapisz
        
        Properties ustawienia = new Properties();
        
        String filename = JOptionPane.showInputDialog(null, "Podaj nazw pliku z reguami", "reguly");        
        
        try {
            
            ZarzadcaRegul zr = se.getZarzadcaRegul();
            
            ustawienia.setProperty("ilosc", ""+zr.size());
            
            for(int i=0; i<zr.size(); i++) {
                Regula r = (Regula)zr.get(i);
               
                String v = "";
                
                v += r.getPoczatek()+";";
                v += r.getPrzesuniecie()+";";
                v += r.getWaga()+";";
                
                v += r.getWzorzec()+";";
                
                v += r.getIloscDifonow()+";";
                
                for(int j=0; j<r.getIloscDifonow(); j++) {
                    v += r.getDifon(j)+";";
                }               
                
               ustawienia.setProperty(""+i, v);
            }
            
//            FileOutputStream out = new FileOutputStream(filename);
//            ustawienia.store(out, "Zestaw regul");
//            out.close();
            
            FileOutputStream out = new FileOutputStream(filename+".xml");
            ustawienia.storeToXML(out, "Zestaw regul");
            out.close();            
            
        } catch(IOException eio) {
            eio.printStackTrace();
        }
        
    }//GEN-LAST:event_bZapiszActionPerformed

    private void bModyfikujActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bModyfikujActionPerformed

        //modyfikuj regule
        
        Regula r = se.getZarzadcaRegul().get(listaRegul.getSelectedIndex());
        
        String wzorzec = JOptionPane.showInputDialog(null, "Podaj wzorzec reguy", r.getWzorzec());
        
        String dd = "";        
        for(int i=0; i<r.getIloscDifonow(); i++) {
            dd += ""+r.getDifon(i)+";";
        }
        
        String difony = JOptionPane.showInputDialog(null, "Podaj zamiane wzorca, difony rozdzielone znakiem rednika (;)", dd);
        
        Vector d = new Vector();
        
        String token = "";
        for(int i=0; i<difony.length(); i++) {
            if(difony.charAt(i)==';') {
                d.add(new String(token));
                token = "";
            } else {
                token += ""+difony.charAt(i);
            }            
        }
        if(token.length()>0) {
            d.add(new String(token));
            token = "";
        }
        
        String[] ds = new String[d.size()];
        for(int i=0; i<d.size(); i++) {
            ds[i] = (String)d.get(i);
        }        
        
        String poczatek = JOptionPane.showInputDialog(null, "Podaj pozycje pocztkow wzorca", ""+r.getPoczatek());
        
        int vpoczatek = 0;
        
        try {
            vpoczatek = Integer.parseInt(poczatek);
        } catch (NumberFormatException e) {
            Toolkit.getDefaultToolkit().beep();
        }
        
        String przesuniecie = JOptionPane.showInputDialog(null, "Podaj przesunicie po wykorzystaniu wzorca", ""+r.getPrzesuniecie());
        
        int vprzesun = wzorzec.length();
        
        try {
            vprzesun = Integer.parseInt(przesuniecie);
        } catch (NumberFormatException e) {
            Toolkit.getDefaultToolkit().beep();
        }
        
        String waga = JOptionPane.showInputDialog(null, "Podaj wag reguy", ""+r.getWaga());
        
        int vwaga = 0;
        
        try {
            vwaga = Integer.parseInt(waga);
        } catch (NumberFormatException e) {
            Toolkit.getDefaultToolkit().beep();
        }
        
        se.getZarzadcaRegul().remove(listaRegul.getSelectedIndex());
        se.getZarzadcaRegul().add(new Regula(vpoczatek, wzorzec, ds, vprzesun, vwaga));
        
        odswiezListe();
        
        
        
    }//GEN-LAST:event_bModyfikujActionPerformed

    private void bUsunActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bUsunActionPerformed

        //usuwa
        
        se.getZarzadcaRegul().remove(listaRegul.getSelectedIndices());
        odswiezListe();
        
    }//GEN-LAST:event_bUsunActionPerformed

    private void bDodajActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bDodajActionPerformed

        //dodawanie nowej reguly
        
        String wzorzec = JOptionPane.showInputDialog(null, "Podaj wzorzec reguy", "Wzorzec", JOptionPane.INFORMATION_MESSAGE);
        String difony = JOptionPane.showInputDialog(null, "Podaj zamiane wzorca, difony rozdzielone znakiem rednika (;)", "Zamiana wzorca", JOptionPane.INFORMATION_MESSAGE);
        
        Vector d = new Vector();
        
        String token = "";
        for(int i=0; i<difony.length(); i++) {
            if(difony.charAt(i)==';') {
                d.add(new String(token));
                token = "";
            } else {
                token += ""+difony.charAt(i);
            }            
        }
        if(token.length()>0) {
            d.add(new String(token));
            token = "";
        }
        
        String[] ds = new String[d.size()];
        for(int i=0; i<d.size(); i++) {
            ds[i] = (String)d.get(i);
        }        
        
        String poczatek = JOptionPane.showInputDialog(null, "Podaj pozycje pocztkow wzorca", "0");
        
        int vpoczatek = 0;
        
        try {
            vpoczatek = Integer.parseInt(poczatek);
        } catch (NumberFormatException e) {
            Toolkit.getDefaultToolkit().beep();
        }
        
        String przesuniecie = JOptionPane.showInputDialog(null, "Podaj przesunicie po wykorzystaniu wzorca", wzorzec.length());
        
        int vprzesun = wzorzec.length();
        
        try {
            vprzesun = Integer.parseInt(przesuniecie);
        } catch (NumberFormatException e) {
            Toolkit.getDefaultToolkit().beep();
        }
        
        String waga = JOptionPane.showInputDialog(null, "Podaj wag reguy", "0");
        
        int vwaga = 0;
        
        try {
            vwaga = Integer.parseInt(waga);
        } catch (NumberFormatException e) {
            Toolkit.getDefaultToolkit().beep();
        }
        
        se.getZarzadcaRegul().add(new Regula(vpoczatek, wzorzec, ds, vprzesun, vwaga));
        
        odswiezListe();
        
    }//GEN-LAST:event_bDodajActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bDodaj;
    private javax.swing.JButton bModyfikuj;
    private javax.swing.JButton bUsun;
    private javax.swing.JButton bWgraj;
    private javax.swing.JButton bZapisz;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JList listaRegul;
    private javax.swing.JScrollPane skrolRegul;
    private javax.swing.JToolBar toolbar;
    // End of variables declaration//GEN-END:variables
    
}
