/*
 * TranskrybowaneFrame.java
 *
 * Created on 11 stycze 2005, 23:14
 */

package jsampa;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.ActionListener;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;
import java.util.Vector;
import javax.swing.ButtonGroup;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JRadioButtonMenuItem;

/**
 *
 * @author michalus
 */
public class TranskrybowanePanel extends JPanel implements MouseListener, MouseMotionListener, ActionListener {
    
    private Transkrybowane t;
    /** Pionowa rozdzielczo */
    private int ZakresPionu = 300;
    private int marginesPoziomy = 25;
    private int marginesPionowy = 25;
    private int dokladnoscPodzialki = 10;
    private boolean podpisacSkladowe = true;    
    
    private JPopupMenu menu;
    private JMenuItem zapisz, odegraj, zapiszodegraj;    
    private JRadioButtonMenuItem zmienczas, zmienpitch;
    private ButtonGroup grupa;    
    
    private Vector etykietyWzorcow;
    private Vector wzorce;
        
    /** Creates a new instance of TranskrybowaneFrame */
    public TranskrybowanePanel(Transkrybowane t) { 
        this.t = t;        
        
        setBackground(Color.WHITE);
        addMouseListener(this);
        addMouseMotionListener(this);
        
        menu = new JPopupMenu("Opcje");
        zapisz = new JMenuItem("Zapisz");
        odegraj = new JMenuItem("Mbrola");
        zapiszodegraj = new JMenuItem("Zapisz&Mbrola");
        
        zmienczas = new JRadioButtonMenuItem("Zmie czas", true);
        zmienpitch = new JRadioButtonMenuItem("Zmie pitch", false);
        
        grupa = new ButtonGroup();  //grupa radio zeby sie razem nie zaklikiwaly
        grupa.add(zmienczas);
        grupa.add(zmienpitch);
       
        
        menu.add(zmienczas);
        menu.add(zmienpitch);
        menu.addSeparator();
        
        zmienczas.addActionListener(this);
        zmienpitch.addActionListener(this);
        
        zapisz.addActionListener(this);
        odegraj.addActionListener(this);
        zapiszodegraj.addActionListener(this);
        
        menu.add(zapisz);
        menu.add(odegraj);
        menu.addSeparator();
        menu.add(zapiszodegraj);       

    }
    
    public void paint(Graphics g) {
        super.paint(g);
        
        //obramowanie roboczego panelu, odzielenie od marginesow
        g.setColor(Color.LIGHT_GRAY);
        g.drawRect((int)Math.round((double)marginesPoziomy/2), (int)Math.round((double)marginesPionowy/2), getWidth()-marginesPoziomy, getHeight()-marginesPionowy);
        
        g.drawString("Wykres wartoci wysokoci gosu (pitch)", 25, getHeight()-50);
        g.drawString("Wykres wartoci dugoci trwania", 25, getHeight()-35);
        g.drawString("(Wicej opcji pod prawym klawiszem myszy)", 25, getHeight()-20);
        
        g.setColor(Color.RED);
        g.fillRect(15, getHeight()-43, 8, 8);
        g.setColor(Color.BLUE);
        g.fillRect(15, getHeight()-58, 8, 8);
        
        //wyznaczenie wielkosci blokow
        double bx = (double)(this.getWidth()-marginesPoziomy*2)/(t.w.size()-1);
        double by = (double)(this.getHeight()-marginesPionowy*2)/ZakresPionu;
        
        //rysowanie podzialki        
        for(int i=0; i<=dokladnoscPodzialki; i++) {
            
            int wysokosc = (int)(Math.round((double)(getHeight()-marginesPionowy*2)/dokladnoscPodzialki)*i);
            int wartosc = (int)(wysokosc/by);
            
            g.setColor(Color.LIGHT_GRAY);
            g.drawLine(
                    (int)Math.round((double)marginesPoziomy/4), 
                    getHeight()-marginesPionowy-wysokosc-1, 
                    (int)Math.round((double)marginesPoziomy/2), 
                    getHeight()-marginesPionowy-wysokosc-1);
            
            g.setColor(Color.GRAY);
            g.drawString(
                    ""+wartosc, 
                    2, 
                    getHeight()-marginesPionowy-wysokosc-2);
        } 
        
        //wyrysowanie wykresu czasowego
        g.setColor(Color.RED);
        g.fillOval(marginesPoziomy-2, getHeight()-marginesPionowy-((int)(t.czas[0]*by))-2, 5, 5);                
        g.drawOval(marginesPoziomy-4, getHeight()-marginesPionowy-((int)(t.czas[0]*by))-4, 9, 9);
        
        if(podpisacSkladowe)
            g.drawString(((String)t.w.get(0)), marginesPoziomy-2, getHeight()-marginesPionowy-((int)(t.czas[0]*by))-25);
        
        //wyrysowanie wykresu wysokosci glosu
        g.setColor(Color.BLUE);
        g.fillOval(marginesPoziomy-2, getHeight()-marginesPionowy-((int)(t.pitch[0]*by))-2, 5, 5);                
        g.drawOval(marginesPoziomy-4, getHeight()-marginesPionowy-((int)(t.pitch[0]*by))-4, 9, 9);        
        if(podpisacSkladowe)
            g.drawString(((String)t.w.get(0)), marginesPoziomy-2, getHeight()-marginesPionowy-((int)(t.pitch[0]*by))-25);
        
        for(int i=1; i<t.w.size(); i++) {
            
            //wyrysowanie wykresu czasowego
            g.setColor(Color.RED);
            g.fillOval(marginesPoziomy+((int)(i*bx))-2, getHeight()-marginesPionowy-((int)(t.czas[i]*by))-2, 4, 4);            
            g.drawLine(marginesPoziomy+(int)(i*bx), getHeight()-marginesPionowy-(int)(t.czas[i]*by), marginesPoziomy+(int)((i-1)*bx), getHeight()-marginesPionowy-(int)(t.czas[i-1]*by));            
            g.drawOval(marginesPoziomy+((int)(i*bx))-4, getHeight()-marginesPionowy-((int)(t.czas[i]*by))-4, 8, 8);
            
            if(podpisacSkladowe)
                g.drawString(((String)t.w.get(i)), marginesPoziomy+((int)(i*bx))-2, getHeight()-marginesPionowy-((int)(t.czas[i]*by))-25);
            
            //wyrysowanie wykresu wysokosci glosu
            g.setColor(Color.BLUE);
            g.fillOval(marginesPoziomy+((int)(i*bx))-2, getHeight()-marginesPionowy-((int)(t.pitch[i]*by))-2, 4, 4);            
            g.drawLine(marginesPoziomy+(int)(i*bx), getHeight()-marginesPionowy-(int)(t.pitch[i]*by), marginesPoziomy+(int)((i-1)*bx), getHeight()-marginesPionowy-(int)(t.pitch[i-1]*by));
            g.drawOval(marginesPoziomy+((int)(i*bx))-4,getHeight()- marginesPionowy-((int)(t.pitch[i]*by))-4, 8, 8);
            
            if(podpisacSkladowe)
                g.drawString(((String)t.w.get(i)), marginesPoziomy+((int)(i*bx))-2, getHeight()-marginesPionowy-((int)(t.pitch[i]*by))-25);            
            
        }

    }

    public void mouseReleased(java.awt.event.MouseEvent e) {
        
        if (e.isPopupTrigger()) {            
            menu.show(e.getComponent(), e.getX(), e.getY());
        }
    }
    
    public void mousePressed(java.awt.event.MouseEvent e) {
        
        if (e.isPopupTrigger()) {            
            menu.show(e.getComponent(), e.getX(), e.getY());
        }
    }

    public void mouseExited(java.awt.event.MouseEvent e) {
    }

    public void mouseEntered(java.awt.event.MouseEvent e) {
    }

    public void mouseClicked(java.awt.event.MouseEvent e) {
        
        if(e.getButton()==e.BUTTON1) {
            if(this.zmienczas.isSelected()) {
                int x = e.getX() - marginesPoziomy;
                int y = getHeight()- e.getY() - marginesPionowy;
                
                double bx = (double)(this.getWidth()-marginesPoziomy*2)/(t.w.size()-1);
                double by = (double)(this.getHeight()-marginesPionowy*2)/ZakresPionu;
                
                if((int)Math.round(x / bx)>=0 && (int)Math.round(x / bx)<t.czas.length) {
                    if((int)Math.round(y / by)>=0) {
                        t.czas[(int)Math.round(x / bx)] = (int)Math.round(y / by);
                    } else {
                        t.czas[(int)Math.round(x / bx)] = 0;
                    }                            
                    repaint();
                }
                
            } if(this.zmienpitch.isSelected()) {
                int x = e.getX() - marginesPoziomy;
                int y = getHeight()- e.getY() - marginesPionowy;
                
                double bx = (double)(this.getWidth()-marginesPoziomy*2)/(t.w.size()-1);
                double by = (double)(this.getHeight()-marginesPionowy*2)/ZakresPionu;
                
                if((int)Math.round(x / bx)>=0 && (int)Math.round(x / bx)<t.pitch.length) {
                    if((int)Math.round(y / by)>=0) {
                        t.pitch[(int)Math.round(x / bx)] = (int)Math.round(y / by);
                    } else {
                        t.pitch[(int)Math.round(x / bx)] = 0;
                    }
                    repaint();
                }
                
            }
        }
        
    }

    /** Obsluguje wyliczanie i odswiezanie tooltipa opisujacego polozenie aktualnego segmentu
     */
    public void mouseMoved(java.awt.event.MouseEvent e) {
        int x = e.getX() - marginesPoziomy;
        int y = getHeight()- e.getY() - marginesPionowy;
        
        double bx = (double)(this.getWidth()-marginesPoziomy*2)/(t.w.size()-1);
        double by = (double)(this.getHeight()-marginesPionowy*2)/ZakresPionu;
        
        x = (int)Math.round(x / bx);
        
        if(x>=0 && x<t.czas.length) {
            setToolTipText(" {"+(String)t.w.get(x)+"} t~"+t.czas[x]+" p~"+t.pitch[x]);
        }
    }

    public void mouseDragged(java.awt.event.MouseEvent e) {
    }

    /** Obsluguje klikniecia na JPopupMenu
     */
    public void actionPerformed(java.awt.event.ActionEvent e) {
        
        if(e.getSource()==zmienczas) {
            // --
        } else if(e.getSource()==zmienpitch) {
            // --
        } else if(e.getSource()==zapisz) {
            t.write();
        } else if(e.getSource()==odegraj) {
            odegraj();
        } else if(e.getSource()==zapiszodegraj) {
            t.write();
            odegraj();
        }
    }
    
    /** Odegranie zapisanego na dysku pliku
     */
    private void odegraj() {
        
        Properties ustawienia = new Properties();
        
        try {
            FileInputStream in = new FileInputStream("ustawienia"); //wczytanie zapisanych ustawien
            ustawienia.load(in);
            in.close();
        } catch(IOException e) {
            System.out.println("Ustawienia nie byy wczeniej zapisywane.");
        }
        
        try {            
            
            String path = "";
            
            if(ustawienia.containsKey("path")) {
                path = ustawienia.getProperty("path", "");  //odczytanie zapisanej sciezki
            }    
            
            Process p = Runtime.getRuntime().exec(path+" sampa_output.pho");
            
        } catch(IOException e) {
            System.out.println("Nie mozna bylo zapisac ustawien programu!");
            e.printStackTrace();
        }
    }
    
}
